
QT += gui network xmlpatterns

DEFINES += NXT_LIBRARY

INCLUDEPATH += ./src/

SOURCES += \
    src/connection/rest/restconnection.cpp \
    src/connection/rest/restconnection_pimpl.cpp \
    src/connection/ssh/nxtsshkeydeploymentdialog.cpp \
    src/connection/ssh/nxtsshparser.cpp \
    src/device/hardware/nxthardwaredevice.cpp \
    src/device/hardware/nxthardwaredevicerest.cpp \
    src/device/hardware/nxthardwaredevicerest_pimpl.cpp \
    src/device/hardware/nxthardwaredevicewidget.cpp \
    src/device/hardware/nxthardwaredevicewizard.cpp \
    src/device/hardware/nxthardwaredevicewizardpages.cpp \
    src/device/nxtdevice.cpp \
    src/device/nxtdevicedebugsupport.cpp \
    src/device/nxtdevicefactory.cpp \
    src/device/nxtdevicetester.cpp \
    src/device/nxtdevicexmlparser.cpp \
    src/nxtlogging.cpp \
    src/nxtplugin.cpp \
    src/nxtsettings.cpp \
    src/parser/nxtbundleparser.cpp \
    src/parser/nxtdeployparser.cpp \
    src/qtc/nxtprojectlistener.cpp \
    src/qtc/nxtqtversion.cpp \
    src/qtc/nxtqtversionfactory.cpp \
    src/qtc/nxtsdk.cpp \
    src/qtc/nxtsdkdetailswidget.cpp \
    src/qtc/nxtsdkkitinformation.cpp \
    src/qtc/nxtsdkmanager.cpp \
    src/qtc/nxtsdkselectiondialog.cpp \
    src/qtc/nxttarget.cpp \
    src/qtc/nxttargetkitinformation.cpp \
    src/qtc/nxttargetsxmlparser.cpp \
    src/qtc/nxttoolchain.cpp \
    src/steps/build/nxtabstractbuildstep.cpp \
    src/steps/build/nxtbuildsteps.cpp \
    src/steps/deploy/nxtdeployconfiguration.cpp \
    src/steps/deploy/nxtdeploysteps.cpp \
    src/steps/run/nxtrunconfiguration.cpp \
    src/steps/run/nxtrunconfigurationfactory.cpp \
    src/steps/run/nxtrunrestconfiguration.cpp \
    src/ui/mode/nxtmode.cpp \
    src/ui/options/nxtgeneraloptionspage.cpp \
    src/ui/options/nxtgeneraloptionswidget.cpp \
    src/ui/options/nxtoptionspage.cpp \
    src/ui/options/nxtoptionswidget.cpp \
    src/vm/nxtabstractvmstartstep.cpp \
    src/vm/nxtaddvmstartbuildstepprojectlistener.cpp \
    src/vm/nxtconnection.cpp \
    src/vm/nxtconnectionmanager.cpp \
    src/vm/nxtvirtualboxmanager.cpp \
    src/steps/run/nxtresttargetrunner.cpp

HEADERS += \
    src/connection/rest/restconnection.h \
    src/connection/rest/restconnection_pimpl.h \
    src/connection/ssh/nxtsshkeydeploymentdialog.h \
    src/connection/ssh/nxtsshparser.h \
    src/device/hardware/nxthardwaredevice.h \
    src/device/hardware/nxthardwaredevicerest.h \
    src/device/hardware/nxthardwaredevicerest_pimpl.h \
    src/device/hardware/nxthardwaredevicewidget.h \
    src/device/hardware/nxthardwaredevicewizard.h \
    src/device/hardware/nxthardwaredevicewizardpages.h \
    src/device/nxtdevice.h \
    src/device/nxtdevicedebugsupport.h \
    src/device/nxtdevicefactory.h \
    src/device/nxtdevicetester.h \
    src/device/nxtdevicexmlparser.h \
    src/nxtconstants.h \
    src/nxticons.h \
    src/nxtlogging.h \
    src/nxtplugin.h \
    src/nxtsettings.h \
    src/parser/nxtbundleparser.h \
    src/parser/nxtdeployparser.h \
    src/qtc/nxtprojectlistener.h \
    src/qtc/nxtqtversion.h \
    src/qtc/nxtqtversionfactory.h \
    src/qtc/nxtsdk.h \
    src/qtc/nxtsdkdetailswidget.h \
    src/qtc/nxtsdkkitinformation.h \
    src/qtc/nxtsdkmanager.h \
    src/qtc/nxtsdkselectiondialog.h \
    src/qtc/nxttarget.h \
    src/qtc/nxttargetkitinformation.h \
    src/qtc/nxttargetsxmlparser.h \
    src/qtc/nxttoolchain.h \
    src/qtc/nxttoolchainfactory.h \
    src/steps/build/nxtabstractbuildstep.h \
    src/steps/build/nxtbuildsteps.h \
    src/steps/deploy/nxtdeployconfiguration.h \
    src/steps/deploy/nxtdeploysteps.h \
    src/steps/run/nxtrunconfiguration.h \
    src/steps/run/nxtrunconfigurationfactory.h \
    src/steps/run/nxtrunrestconfiguration.h \
    src/ui/mode/nxtmode.h \
    src/ui/options/nxtgeneraloptionspage.h \
    src/ui/options/nxtgeneraloptionswidget.h \
    src/ui/options/nxtoptionspage.h \
    src/ui/options/nxtoptionswidget.h \
    src/vm/nxtabstractvmstartstep.h \
    src/vm/nxtaddvmstartbuildstepprojectlistener.h \
    src/vm/nxtconnection.h \
    src/vm/nxtconnectionmanager.h \
    src/vm/nxtvirtualboxmanager.h \
    src/steps/run/nxtresttargetrunner.h

RESOURCES += \
    nxt.qrc

FORMS += \
    src/device/hardware/nxthardwaredevicewidget.ui \
    src/device/hardware/nxthardwaredevicewidgetauthorizedialog.ui \
    src/device/hardware/nxthardwaredevicewizardselectionpage.ui \
    src/device/hardware/nxthardwaredevicewizardsetuppage.ui \
    src/qtc/nxtsdkdetailswidget.ui \
    src/qtc/nxtsdkselectiondialog.ui \
    src/steps/deploy/nxtdeploystep.ui \
    src/ui/options/nxtgeneraloptionswidget.ui \
    src/ui/options/nxtoptionswidget.ui \

TRANSLATIONS = \
    i18n/NXT_en.ts \
    i18n/NXT_de.ts \
    i18n/NXT_fr.ts \

win32-msvc* {
    LIBS += ws2_32.lib
}

# this is a hack to access a private member which should be protected in QtCreator's source code
DEFINES += HACK_BYPASS_PRIVATE_ENVIRONMENT_ACCESS

# ----------------------------------------------------------------------------------------------------------------------

# Qt Creator linking

## Either set the IDE_SOURCE_TREE when running qmake,
## or set the QTC_SOURCE environment variable, to override the default setting
#isEmpty(IDE_SOURCE_TREE): IDE_SOURCE_TREE = $$absolute_path($$(QTC_SOURCE)) # from ENV
isEmpty(IDE_SOURCE_TREE): IDE_SOURCE_TREE = $$absolute_path("$${PWD}/../../qtcreator") # fallback: relative to this project

## Either set the IDE_BUILD_TREE when running qmake,
## or set the QTC_BUILD environment variable, to override the default setting
#isEmpty(IDE_BUILD_TREE): IDE_BUILD_TREE = $$absolute_path($$(QTC_BUILD)) # from ENV
CONFIG(release, debug|release) {
    isEmpty(IDE_BUILD_TREE): IDE_BUILD_TREE = $$absolute_path("$${OUT_PWD}/../../qtcreator") # fallback: relative to this project
}
CONFIG(debug, debug|release) {
    isEmpty(IDE_BUILD_TREE): IDE_BUILD_TREE = $$absolute_path("$${OUT_PWD}/../../qtcreator") # fallback: relative to this project
}

# ----------------------------------------------------------------------------------------------------------------------

QT_CREATOR_PLUGIN_PRI = "src/qtcreatorplugin.pri"
!exists($$absolute_path("$${IDE_SOURCE_TREE}/$${QT_CREATOR_PLUGIN_PRI}")) {
    error("File '$${QT_CREATOR_PLUGIN_PRI}' in IDE_SOURCE_TREE=$${IDE_SOURCE_TREE} not found.")
}

# ----------------------------------------------------------------------------------------------------------------------

## uncomment to build plugin into user config directory
## <localappdata>/plugins/<ideversion>
##    where <localappdata> is e.g.
##    "%LOCALAPPDATA%\QtProject\qtcreator" on Windows Vista and later
##    "$XDG_DATA_HOME/data/QtProject/qtcreator" or "~/.local/share/data/QtProject/qtcreator" on Linux
##    "~/Library/Application Support/QtProject/Qt Creator" on OS X
#USE_USER_DESTDIR = yes

###### If the plugin can be depended upon by other plugins, this code needs to be outsourced to
###### <dirname>_dependencies.pri, where <dirname> is the name of the directory containing the
###### plugin's sources.

QTC_PLUGIN_NAME = NXT
PROVIDER = IDS

QTC_LIB_DEPENDS += \
    utils \
    ssh

QTC_PLUGIN_DEPENDS += \
    coreplugin \
    debugger \
    projectexplorer \
    qmakeprojectmanager \
    remotelinux

QTC_PLUGIN_RECOMMENDS += \
    # optional plugin dependencies. nothing here at this time

include($$absolute_path("$${IDE_SOURCE_TREE}/$${QT_CREATOR_PLUGIN_PRI}"))

DEFINES += QT_NO_WEBKIT

# ----------------------------------------------------------------------------------------------------------------------

win32-g++ {
    # https://gcc.gnu.org/onlinedocs/gcc/Warning-Options.html
    QMAKE_CXXFLAGS += \
        #-Wall \
        #-Wextra \
        #-Werror \
        #-Wpedantic \
}
win32-msvc* {
    # https://msdn.microsoft.com/de-de/library/thxezb7y.aspx
    QMAKE_CXXFLAGS += \
        #/Wall \
        #/WX \
}
# ----------------------------------------------------------------------------------------------------------------------

DEFINES += IDS_NXT

### optional
#DEFINES += IDS_NXT_DEBUG
DEFINES += IDS_NXT_GDBENGINE_PATCH

DEFINES += IDS_NXT_OCEAN

# ----------------------------------------------------------------------------------------------------------------------

resources_xsd.path = $${IDE_BUILD_TREE}/share/qtcreator/nxt/
resources_xsd.files += _resources/QTC/share/qtcreator/nxt/*
INSTALLS += resources_xsd

contains(DEFINES, IDS_NXT_OCEAN) {
    resources_wizard_vapp.path = $${IDE_BUILD_TREE}/share/qtcreator/templates/wizards/nxt/nxt-vapp/
    resources_wizard_vapp.files += _resources/QTC/share/qtcreator/templates/wizards/nxt/vegas64/nxt-vapp/*
    INSTALLS += resources_wizard_vapp

    resources_wizard_plugin.path = $${IDE_BUILD_TREE}/share/qtcreator/templates/wizards/nxt/nxt-plugin/
    resources_wizard_plugin.files += _resources/QTC/share/qtcreator/templates/wizards/nxt/vegas64/nxt-plugin/*
    INSTALLS += resources_wizard_plugin

    resources_icon.path = $${IDE_BUILD_TREE}/share/qtcreator/nxt/
    resources_icon.files += $${IDE_SOURCE_TREE}/src/plugins/coreplugin/images/NXT.ico
    INSTALLS += resources_icon

    resources_app_icon.path = $${IDE_BUILD_TREE}/share/qtcreator/nxt/
    resources_app_icon.files += images/icon-s-nxt-qtcreator@2x.png
    INSTALLS += resources_app_icon

    resources_app_launcher.path = $${IDE_BUILD_TREE}/share/qtcreator/nxt/
    resources_app_launcher.files += _resources/cpack_linux/IdsNxtVisionAppCreator.desktop
    INSTALLS += resources_app_launcher
}

unix {
    INSTALLS -= target
}
