#include "nxtabstractbuildstep.h"

#include <coreplugin/icore.h>
#include <projectexplorer/target.h>
#include <utils/qtcassert.h>

using namespace Core;
using namespace ProjectExplorer;

namespace Nxt {
namespace Internal {

class NxtAbstractBuildStepConfigWidget : public SimpleBuildStepConfigWidget
{
    Q_OBJECT

public:
    NxtAbstractBuildStepConfigWidget(NxtAbstractBuildStep *step)
        : SimpleBuildStepConfigWidget(step)
    {
    }

    QString summaryText() const override
    {
        return QString::fromLatin1("<b>%1</b>")
            .arg(displayName());
    }
};

NxtAbstractBuildStep::NxtAbstractBuildStep(BuildStepList *bsl, Core::Id id)
    : AbstractProcessStep(bsl, id)//BuildStep(bsl, id)
{

}

bool NxtAbstractBuildStep::init(QList<const BuildStep *> &earlierSteps)
{
    Q_UNUSED(earlierSteps);

    return true;
}

void NxtAbstractBuildStep::run(QFutureInterface<bool> &fi)
{
    emit addOutput(tr("%1: override run").arg(displayName()), OutputFormat::ErrorMessage);
    reportRunResult(fi, false);
}

BuildStepConfigWidget *NxtAbstractBuildStep::createConfigWidget()
{
    return new NxtAbstractBuildStepConfigWidget(this);
}

bool NxtAbstractBuildStep::immutable() const
{
    return false;
}

/*
bool NxtAbstractBuildStep::runInGuiThread() const
{
    return true;
}
*/

} // namespace Internal
} // namespace Nxt

#include "nxtabstractbuildstep.moc"
