/****************************************************************************
**
** Copyright (C) 2014 Jolla Ltd.
** Contact: http://jolla.com/
**
** This file is part of Qt Creator.
**
** GNU Lesser General Public License Usage
** Alternatively, this file may be used under the terms of the GNU Lesser
** General Public License version 2.1 as published by the Free Software
** Foundation and appearing in the file LICENSE.LGPL included in the
** packaging of this file.  Please review the following information to
** ensure the GNU Lesser General Public License version 2.1 requirements
** will be met: http://www.gnu.org/licenses/old-licenses/lgpl-2.1.html.
**
** Other Usage
**
** Alternatively, this file may be used in accordance with the terms and
** conditions contained in a signed written agreement between you and Digia.
**
****************************************************************************/

#ifndef NXTGENERALOPTIONSWIDGET_H
#define NXTGENERALOPTIONSWIDGET_H

#include <qtc/nxtsdk.h>

#include <QWidget>

namespace Nxt {
namespace Internal {

namespace Ui {
class NxtGeneralOptionsWidget;
}

class NxtGeneralOptionsWidget : public QWidget
{
    Q_OBJECT
public:
    explicit NxtGeneralOptionsWidget(QWidget *parent = nullptr);
    ~NxtGeneralOptionsWidget() override;

    void store();
    QString searchKeywords() const;

private:
    Ui::NxtGeneralOptionsWidget *m_ui;
};

} // namespace Internal
} // namespace Nxt

#endif // NXTGENERALOPTIONSWIDGET_H
